import java.awt.*;
import java.applet.*;

public class BarMeterApplet extends Applet {

    // Double Buffering pC[W
    transient protected Image image = null;
    transient protected Graphics graphics = null;

    // ʂ̑傫Ɋ֘AvpeB
    protected int width;
    protected int height;

    // [^̍ŏ/ől
    protected double minimum;
    protected double maximum;

    // f[^NX
    protected DataCreator dataCreator = null;

    // [^wl
    protected double value = 0;

    public void init(){
        // HTMLlo
        minimum = Double.valueOf(getParameter("minimum")).doubleValue();
        maximum = Double.valueOf(getParameter("maximum")).doubleValue();

        //  DataCreator ̎ނo
        String dataCreatorName = getParameter("data");
        try{
            // DataCreator ̐
            Class dataCreatorClass = Class.forName(dataCreatorName);
            dataCreator = (DataCreator)dataCreatorClass.newInstance();
        }catch(ClassNotFoundException ex){
            System.err.println("Can't found such a class!");
            System.exit(1);
        }catch(InstantiationException ex){
            System.err.println("Can't instance such a class!");
            System.exit(1);
        }catch(IllegalAccessException ex){
            System.err.println("Can't instance such a class!");
            System.exit(1);
        }
    }

    public void start(){
        dataCreator.setBarMeterApplet(this);
        dataCreator.start();
    }

    public void setValue(double value){
        this.value = value;
        repaint();
    }

    // o[̕`
    protected void drawBar(Graphics g, double value){

        // wl̑ΒlZo
        double val = (value - minimum)/ (maximum - minimum);

        // Ot̍ɕϊ
        val *= height;

        int y = height - (int)val;
        int h = (int)val;

        // o[̐Fݒ
        g.setColor(Color.yellow);

        // o[`
        g.fillRect(0, y, width, h);
    }

    public void update(Graphics g){
        // ʂ̃NA͍sȂ
        paint(g);
    }

    public void paint(Graphics g){

        // _uobt@Op̃C[WȂ΁A
        // AOtBbNReLXgB
        if(image == null){
            // Avbg̃TCY
            Dimension size = this.getSize();
            width = size.width;
            height = size.height;

            // C[W̐
            image = this.createImage(width, height);
            graphics = image.getGraphics();
        }

        // wiFœhԂ
        graphics.setColor(this.getBackground());
        graphics.fillRect(0, 0, width, height);

        // o[̕`
        drawBar(graphics, value);

        // C[Wobt@̕`
        g.drawImage(image, 0, 0, width, height, this);
    }
}
